package com.hzs.common.core.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

/**
 * 会员系统分类
 */
@AllArgsConstructor
@Getter
public enum ESystemType {

    /**
     * 默认（新零售）
     */
    DEFAULT(2, "新零售", 0),

    /**
     * 全部
     */
    ALL(9, "全部", 1),

    ;

    /**
     * 实际值
     */
    private final int value;
    /**
     * 显示标签
     */
    private final String label;
    /**
     * 是否启用（0=是,1=否） -- 来源EYesNo
     */
    private final int enable;

    /**
     * 根据枚举值获取枚举
     *
     * @param value
     * @return
     */
    public static ESystemType getEnumByValue(int value) {
        for (ESystemType enums : ESystemType.values()) {
            if (enums.value == value) {
                return enums;
            }
        }
        return null;
    }

    /**
     * 获取有效系统类型
     *
     * @return
     */
    public static List<ESystemType> getEnableList() {
        List<ESystemType> list = new ArrayList<>();
        for (ESystemType enums : ESystemType.values()) {
            if (EYesNo.YES.getIntValue() == enums.getEnable()) {
                list.add(enums);
            }
        }
        return list;
    }

}
